
#include "common.h"

// kernel to binarize an array
__global__ void binarize_kernel( /* TODO */)
{
  /* TODO */
}



__host__ void binarize_cuda(std::vector<float>& values, float threshold)
{
  // Temporary buffer stored on GPU's memory ("d_" for "device")
  float *d_values;
  
  // Step 1 - Allocate the buffer on the device using cudaMalloc
  // (tips: values.size() returns the number of values)
  CUDA_SAFE_CALL( cudaMalloc( /* TODO */ ) );
  
  // Step 1 - Copy the values from the host memory to the device memory (from values to d_values)
  CUDA_SAFE_CALL( cudaMemcpy( /* TODO */ ) );

  // Step 3 - Determine the CUDA block and grid sizes
  // Be careful, the type dim3 stores 16bits integer values, so the maximal dimension is 65535
  // The maximal size of a block is also limited (from 256 to 2048 depending on the hardware)
  dim3 DimBlock( /* TODO */ );
  dim3 DimGrid( /* TODO */ );

  // This is a timer to measure the running time.
  Timer t;
  startTimer(t);

  // Step 4 - Call the kernel
  binarize_kernel<<< DimGrid, DimBlock >>> ( /* TODO */ );
  
  // Wait until the device finished its job
  CUDA_SAFE_CALL( cudaThreadSynchronize() );
  stopTimer(t);
  
  std::cout << "CUDA time to binarize " << values.size() << " values: " << t << "s\n";
  

  // Step 5 - Read back the values from the device
  CUDA_SAFE_CALL( cudaMemcpy( /* TODO */ ));

  // Step 6 - Free device memory
  cudaFree(d_values);
}
